CON

  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000

'' Motor constants
  
  xDIRECTION = 24 
  xDISABLE   = 26
 

  yDIRECTION = 10 
  yDISABLE   = 12


  xPULSE     = 25
  yPULSE     = 11

  xHOM       = 22
  yHOM       = 21

  xLIM       = 23
  yLIM       = 20

  xENCODER   = 25
  xON        = 26
  
  yENCODER   = 11
  yON        = 12

  MINSPEED   = 20
  MAXSPEED   = 4500

  MINACCEL   = 1
  MAXACCEL   = 20

'' Communication constants

  XbeeRX     = 8
  XbeeTX     = 9
  ArdRX      = 14
  ArdTX      = 15

  XbeeBAUD   = 9600
  ArdBAUD    = 9600  
  
VAR
        long          xMotor, yMotor                        ' Motor pulse counter registers loaded into motor object.
        long          xspeed , yspeed, xaccel, yaccel
        long          xPosition, yPosition, xworld, yworld, xoffset, yoffset   ' Encoder position registers loaded from pos object.... do not change!
        long          xOld, xNew, yOld, yNew
        long          speedOld, speedNew , accel, position, freq
        long          Address
        long          compassValues[12]
        
        byte          char[128]
        
OBJ

  motor : "stepper_clocks"
  pos   : "stepper_encoder-3"
'  pst   : "Parallax Serial Terminal"
  xbee  : "XbeeAPIobj"
'  ard   : "FullDuplexSerial"
  fmt   : "Format"
  compass  : "Compass"

PUB  start 

' pst.Start(115200)
 xbee.Start(XbeeRX, XbeeTX, 0 , XbeeBAUD)
' ard.Start(ArdRX, ArdTX, 0, ArdBAUD)
 compass.startCompass(@compassValues, $E0)     'starts up compass sensors at maximum gain

    dira[xDIRECTION]~~
    dira[xPULSE]~~ 
    dira[xDISABLE]~~
    dira[xLIM]~
    dira[yDIRECTION]~~
    dira[yPULSE]~~ 
    dira[yDISABLE]~~    
    dira[yLIM]~
 
    xMotor  := 0
    yMotor  := 1
    accel    := 5
    speedNew := MINSPEED
    speedOld := MINSPEED
              
    xspeed := MINSPEED
    yspeed := MINSPEED
    xaccel := MINACCEL
    yaccel := MINACCEL
    xworld := 0
    yworld := 0
    xoffset := 0
    yoffset := 0
             
    freq := 60 * clkfreq / 200 / 2  / MINSPEED   ' ctr freq = clkfreq (pulses per sec) / steps per revolution / 10 microsteps per step / pulses per microstep / revs per sec
                              
    motor.start(xMotor, xPULSE, yPULSE )    ' set up 1 cog with 2 counters (ctra & ctrb); cog ctra: APIN = xPULSE; cog ctrb: APIN = yPULSE                                             
    motor.set_period(xMotor, freq , freq )  ' set the period for ctra module (xMotor)
    motor.set_period(yMotor, freq , freq )  ' set the period for ctrb module (yMotor)

    pos.Start(@xPosition)                   ' start encoder pulse counting cog

waitcnt(clkfreq* 3 + cnt)

'===============================Motor Commands===================================
'
'                               s = motor set speed
'                               i = motor move incremental
'                               a = motor set acceleration
'                               o = motor on
'                               k = motor off
'                               b = motor backward
'                               f = motor forward
'                               p = hold motor
'                               r = release motor
'                               m = move to x, y position
'                               h = home motor
'
'                               all commands are followed by axis x or y
'                               s, p and a commands ask for values                              
   
repeat  
   Address := xbee.Rx_API_Str(@char)             
  if Address == $40783F40
     
    case char[0]
      "s":
       'pst.Str(String("Current speed: "))            
       'case char[1]
        '"x":
         ' pst.dec(xspeed)
        '"y":
          'pst.dec(yspeed)
     
       'pst.Str(String($0D, "Input motor speed (20 < rpm < 4500):", $0D ))    
       speedNew := fmt.atoi(@char[2])
        
       case char[1]
        "x":            
         rampSpeed(xMotor, xspeed, speedNew)
        "y":
         rampSpeed(yMotor, yspeed, speedNew)            
       
      "i":
     
       ' pst.Str(String("Current position: "))            
       'case char[1]
       ' "x":
        '  pst.dec(getPosition(xMotor))
       ' "y":
       '   pst.dec(getPosition(yMotor))
          
       'pst.str(string($0D,"Enter incremental steps: ", $0D))
       position := fmt.atoi(@char[2])
            
       case char[1]
        "x":
         positionMotor(xMotor, position)
        "y":
         positionMotor(yMotor, position)
          
     "a":
      'pst.Str(String("Current acceleration: "))                                    
      'case char[1]
      ' "x":    
         'pst.dec(xaccel)
       '"y":
         'pst.dec(yaccel)    
      
      'pst.Str(String($0D, "Input motor acceleration:", $0D ))    
      accel := fmt.atoi(@char[2])
      
      case char[1]
       "x": 
         setAccel(xMotor, accel)
       "y":
         setAccel(yMotor, accel) 
          
     "o":
      case char[1]       
       "x":
        onMotor(xMotor)
       "y":
        onMotor(yMotor)
     
     "k":
      case char[1]       
       "x":
        offMotor(xMotor)
       "y":
        offMotor(yMotor)
     
     "b":
      case char[1]       
        "x":
         reverseMotor(xMotor)
        "y":
         reverseMotor(yMotor)
         
     "f":
      case char[1]       
        "x":
         forwardMotor(xMotor)
        "y":
         forwardMotor(yMotor)
          
     "p":
       case char[1]       
        "x":
         holdmotor(xMotor)
        "y":
         holdmotor(yMotor)
         
     "r":                        
      case char[1]
       "x":
         releaseMotor(xMotor)
       "y":
         releaseMotor(yMotor)
              
     "z":    
      case char[1]
       "x":
         zeroMotor(xMotor)
       "y":
         zeroMotor(yMotor)
            
     "m":
       'pst.str(String("Enter new x position:", $0D))
      ' xNew := pst.decIn
      ' pst.str(String("Enter new y position:", $0D))
      ' yNew := pst.decIn
       moveXY(xNew, yNew)
       
     "h":    
      case char[1]
       "x":
         homeMotor(xMotor)
       "y":
         homeMotor(yMotor)   

     

PRI rampSpeed(motorNum, beginSpeed, endSpeed) | ramp

   case motornum
    0:
     accel := xaccel
    1:
     accel := yaccel

  endSpeed #>= MINSPEED
  endSpeed <#= MAXSPEED

  repeat ramp from beginSpeed to endSpeed step accel                                                                        
    freq :=  60 * clkfreq / 200 / 2 / ramp
    motor.set_period(motorNum, freq, freq)

  case motornum
   0:
    xspeed := endSpeed
   1:
    yspeed := endspeed

PRI setAccel(motorNum, newAccel)

    newAccel #>= MINACCEL
    newAccel <#= MAXACCEL
  
  case motornum
   0:
    xaccel := newAccel
   1:
    yaccel := newAccel

PRI holdMotor(motorNum) | disable

   motor.set_period(motorNum, 0, 0)
   
   case motornum
    0:
     disable := xDISABLE
    1:
     disable := yDISABLE

  outa[disable]~~
     
PRI releaseMotor(motorNum) | disable

   case motornum
    0:
     disable := xDISABLE
    1:
     disable := yDISABLE

  outa[disable]~
        
PRI onMotor(motorNum) | disable, speed, stop
  case motorNum
   0:
    disable := xDISABLE
    speed   := xspeed

   1:
    disable := yDISABLE
    speed   := yspeed

 
  outa[disable]~~
  stop := MINSPEED
  rampSpeed(motorNum, stop , speed)
    
PRI offMotor(motorNum) | disable, speed, stop
  case motorNum
   0:
    disable := xDISABLE
    speed   := xspeed

   1:
    disable := yDISABLE
    speed   := yspeed
 
         
  stop := MINSPEED
  rampSpeed(motorNum, speed, stop)
  outa[disable]~

PRI isOn(motorNum) | disable
    case motornum
     0:   
      disable := xDISABLE
     1:
      disable := yDISABLE
      
    return ina[disable]
    
PRI reverseMotor(motorNum)  | disable, speed, direction, stop
 case motornum
     0:   
      disable   := xDISABLE
      direction := xDIRECTION
      speed     := xspeed
     1:
      disable   := yDISABLE
      direction := yDIRECTION
      speed     := yspeed
      
 if outa[disable] == 0
   outa[direction]~~            
 else
  stop:= MINSPEED
  rampSpeed(motorNum, speed, stop)     
  outa[direction]~~
  rampSpeed(motorNum, stop, speed)
      
PRI forwardMotor(motorNum) | disable, speed, direction, stop
 case motornum
     0:   
      disable   := xDISABLE
      direction := xDIRECTION
      speed     := xspeed
     1:
      disable   := yDISABLE
      direction := yDIRECTION
      speed     := yspeed
      
 if outa[disable] == 0
   outa[direction]~            
 else
  stop := MINSPEED
  rampSpeed(motorNum, speed, stop)     
  outa[direction]~
  rampSpeed(motorNum, stop, speed)

  
PRI positionMotor(motorNum, newPos) | disable, speed, direction, curPos, posPtr

  case motorNum
     0:   
      disable   := xDISABLE
      direction := xDIRECTION
      speed     := xspeed
      posPtr    := @xposition
     1:
      disable   := yDISABLE
      direction := yDIRECTION
      speed     := yspeed
      posPtr    := @yposition


  if newPos < 0
   reverseMotor(motorNum)
  else
   forwardMotor(motorNum)
      
 newPos := ||newPos
      
  if newPos < 2000
   speed := MINSPEED

  onMotor(motorNum)
' releaseMotor(motorNum)
    
  repeat while long[posPtr] < (newPos - 1000)
 
  speedNew :=  MINSPEED 
  setAccel(motorNum, MAXACCEL)        
  rampSpeed(motorNum, speed, speedNew)
   
  repeat while long[posPtr] < newPos
 
  offMotor(motorNum)
' holdMotor(motorNum)
  
PRI getPosition(motorNum) | worldPtr, offsetPtr
  case motorNum
    0:   
     worldPtr  := @xworld
     offsetPtr := @xoffset
    1:
     worldPtr  := @yworld
     offsetPtr := @yoffset
     
  return long[worldPtr] - long[offsetPtr]
     
PRI zeroMotor(motorNum)
  case motorNum
    0:   
     long[@xoffset] := long[@xworld]
    1:
     long[@yoffset] := long[@yworld]
     
PRI homeMotor(motorNum) | switchNum

  case motorNum
    0:
     switchNum := xHOM     
    1:
     switchNum := yHOM      
' waitcnt(clkfreq*3+cnt)     
  reverseMotor(motorNum)
  rampSpeed(motorNum, MINSPEED, 150)
  onMotor(motorNum)
'  waitpeq(0, |< switchNum, 0)

'    waitcnt(clkfreq+cnt)
'    pst.str(string("xLIM state:"))
    repeat while (ina[switchNum] == 1)
'     pst.position( 13,0)
'     pst.bin(ina[xLIM],1)
     waitcnt(clkfreq/100+cnt)
'  pst.position( 13,0)
'  pst.bin(ina[xLIM],1)
'  pst.str(string(13, "End limit"))
  offMotor(motorNum)
  
  case motorNum
   0:      
    long[@xworld] := long[@xoffset] := 0
   1:        
    long[@yworld] := long[@yoffset] := 0
      
    
PRI moveXY(x1, y1) | x0, y0 , dx, dy, err, e2, sx, sy

' Bresenham's line alogortihm

x0 := xposition
y0 := yposition

  dx := || (x1-x0)

    if x0 < x1
     sx := 20
     forwardMotor(xMotor)
    else
     sx := -20
     reverseMotor(xMotor)

  dy := -||(y1-y0)  

    if y0 < y1
     sy := 20
     forwardMotor(yMotor)
    else
     sy := -20
     reverseMotor(yMotor)


  err := dx + dy
  
  repeat 
   
    positionMotor(xMotor, x0)
    positionMotor(yMotor, y0)
     
    if (||(x0 - x1)< 40) AND (||(y0 -y1) < 40) 
     quit
     
   e2 := 2 * err
   
   if (e2 => dy)
    err += dy
    x0 += sx
    
   if (e2 =< dx)
    err += dx
    y0 += sy

                                                                                                                