VAR

  'Define memory for message handling
  Byte dataSet[127]

  'Generic API frame definitions
  Byte _Start, _LenMSB, _LenLSB, _FrameType, _FrameID,  _CheckSum 

  'TxAPI frame definition
  Long _destAddrHi, _destAddrLo
  Word _destNetAddr 
  Byte  _Radius, _Options

  'Rx API frame definition
  Long _sourceAddrHi, _sourceAddrLo
  Word _sourceNetAddr

DAT  msg1 byte "Message got received!", 13, 0
     msg2 byte "Transmission error!", 13, 0 

OBJ
  FDSerial : "FullDuplexSerial"

Pub Start (RXpin, TXPin, Mode, Baud) |Started, ptr
{{
   Start serial driver - starts a cog
   returns false if no cog available
  
   mode bit 0 = invert rx
   mode bit 1 = invert tx
   mode bit 2 = open-drain/source tx
   mode bit 3 = ignore tx echo on rx

   Sets XBee for low gaurd time for fast AT Command use
}}
          
    Started := FDSerial.Start(RXpin, TXpin, Mode, Baud)
    if Started == -1
      return Started
   


PUB Stop
    '' See FullDuplex Serial Documentation
    FDSerial.Stop


Pub Tx_API_Str (stringptr)| chars, ptr
{{
  Transmit a string to a unit using API mode - 64 bit addressing
  TX response of acknowledgement will be returned if FrameID not 0
  XB.API_RX
  If XB.Status == 0 '0 = Acc, 1 = No Ack

 }}
    _Start       := $7E  
    _LenMSb      := $0
    _LenLSB      := strsize(stringptr) + $0E ' Try to keep total message size < 255 bytes
    _FrameType   := $10  
    _FrameID     := $0                       ' set to 0 for no ack response
    _destAddrHi  := $0013A200
    _destAddrLo  := $40783F40                ' new Xstick for magCrawler
    _destNetAddr := $FFFE                    ' leave at this value with 8 byte addressing
    _Radius      := $0
    _Options     := $0 

  ptr := 0
  dataSet[ptr++] := _Start
  dataSet[ptr++] := _LenMSB                ' Length MSB
  dataSet[ptr++] := _LenLSB                ' Length LSB
  dataSet[ptr++] := _FrameType             ' $10 for TX frame
  dataSet[ptr++] := _FrameID               ' Frame ID 
  dataSet[ptr++] := _destAddrHi >> 24      ' Dest Address MSB
  dataSet[ptr++] := _destAddrHi >> 16      ' Dest Address
  dataSet[ptr++] := _destAddrHi >> 8       ' Dest Address
  dataSet[ptr++] := _destAddrHi            ' Dest Address
  dataSet[ptr++] := _destAddrLo >> 24      ' Dest Address 
  dataSet[ptr++] := _destAddrLo >> 16      ' Dest Address
  dataSet[ptr++] := _destAddrLo >> 8       ' Dest Address
  dataSet[ptr++] := _destAddrLo            ' Dest Address LSB  
  dataSet[ptr++] := _destNetAddr >> 8      ' Dest network Address MSB
  dataSet[ptr++] := _destNetAddr           ' Dest network Address LSB   
  dataSet[ptr++] := _Radius                ' Number of hops set to unlimited
  dataSet[ptr++] := _Options               ' No ACK = 0
                                     
  Repeat strsize(stringptr)         ' Add string to packet
     dataSet[ptr++] := byte[stringptr++]
  _CheckSum := $FF                       ' Calculate checksum
  Repeat chars from 3 to ptr - 1
    _CheckSum := _CheckSum - dataSet[chars]
  dataSet[ptr] := _CheckSum

  
  Repeat chars from 0 to ptr
    FDSerial.tx(dataSet[chars])              ' Send bytes to XBee


Pub Rx_API_Str(stringptr) | ptr

  ptr:=0 
  Repeat 3
    dataSet[ptr++] := FDSerial.rx            ' read 3 bytes of data

  Repeat dataSet[2] + 1
    dataSet[ptr++] := FDSerial.rx            ' accept remainder of data
    
  ptr := 0
  _sourceAddrHi := 0
  _sourceAddrLo := 0
  
  Repeat while ptr < 4
    _sourceAddrHi := _sourceAddrHi << 8 +  dataSet[ptr + 4]
    _sourceAddrLo := _sourceAddrLo << 8 +  dataSet[ptr + 8]
    ptr:= ptr + 1
    
  bytefill(stringptr, 0, 127)
  
  Case dataSet[3]
   
    $8B:   ' Xbee transmit status: no status if Frame ID = $0
      if dataSet[8] == 0
        bytemove(stringptr, @msg1, Strsize(@msg1))
      else
        bytemove(stringptr, @msg2, Strsize(@msg2))
             
    $90:      ' Xbee receive packet
      bytemove(stringptr, @dataSet + 15, dataSet[2]-12)   ' Extract payload from message
      result := _sourceAddrLo
  
Pub Rx_flush

FDSerial.rxflush      