''Counter used as a pulse counter
CON

  POSEDGE = %01010000 

  xENCODER   = 25
  yENCODER   = 11
  
  xON        = 26
  yON        = 12


  xDIRECTION = 10 
  yDIRECTION = 24
  
PUB Start(countAddrA)          


pina :=     xENCODER 
pinb :=  |< xON
pinc :=     yENCODER
pind :=  |< yON
pine :=  |< xDIRECTION
pinf :=  |< yDIRECTION

cognew(@entry, countAddrA)


DAT
                        org
                        
entry                   movs    ctra, pina                   'setup encoder pin for motor A
                        movi    ctra, #POSEDGE               'establish mode and start counter
                        mov     frqa, #1                     'increment for each edge seen

                        movs    ctrb, pinc
                        movi    ctrb, #POSEDGE               'setup encoder pin for motor B
                        mov     frqb, #1

                        mov     addrA, par                   'setup continuous position registers
                        mov     addrB, par
                        add     addrB, #4
                        mov     addrC, par
                        add     addrC, #8
                        mov     addrD, par
                        add     addrD, #12

                        mov     acc1, #0                     ' zero out scratchpad registers
                        mov     acc2, #0
                        mov     acc3, #0
                        mov     acc4, #0
                  
                        
loop                    test    pinb, ina      wz                                   
              if_z      mov     phsa, #0
              if_z      mov     acc2, acc1                        
              if_nz     call    #updateA                     
                        

                        test    pind, ina      wz                                   
              if_z      mov     phsb, #0
              if_z      mov     acc4, acc3                        
              if_nz     call    #updateB
                     
                        jmp     #loop

updateA                 mov     phsa, phsa
                        wrlong  phsa, addrA
                        mov     acc1, acc2
                        test    pine, ina       wz
              if_z      adds    acc1, phsa
              if_nz     subs    acc1, phsa              
                        wrlong  acc1, addrC
updateA_ret             ret

updateB                 mov     phsb, phsb
                        wrlong  phsb, addrB
                        mov     acc3, acc4
                        test    pinf, ina       wz
              if_z      adds    acc3, phsb
              if_nz     subs    acc3, phsb              
                        wrlong  acc3, addrD
updateB_ret             ret                        
                        

pina                    long      0
pinb                    long      0
pinc                    long      0
pind                    long      0
pine                    long      0
pinf                    long      0
addrA                   res       1
addrB                   res       1
addrC                   res       1
addrD                   res       1
acc1                    res       1
acc2                    res       1
acc3                    res       1
acc4                    res       1